#include <stdio.h>

#define MAX 50 
#define N 8
int size;
int ken[N]={27, 6, 78, 2, 62, 12, 60, 16};
int sort_result[MAX];

void merge_conquer_combine(int bbb[], int m, int mid, int n) {
	int i, j, k, t;
	i = m;							         
	j = mid + 1;					         
	k = m;							         

	while (i <= mid && j <= n) {
		if (bbb[i] <= bbb[j]) {
			sort_result[k] = bbb[i];
			i++;
		}
		else {
			sort_result[k] = bbb[j];
			j++;
		}
		k++;
	} 
	
	
	if (i>mid) for (t = j; t <= n; t++, k++) sort_result[k] = bbb[t];
	else for (t = i; t <= mid; t++, k++) sort_result[k] = bbb[t];
	
	 for (t = m; t <= n; t++) 
	 {
		 bbb[t] = sort_result[t];
    	 printf("\n sort-result:%4d t: %4d", sort_result[t], t);

	 } 
	 printf("\n __ --> ");
	 for (t = 0; t<size; t++) printf("%4d ", bbb[t]);  
     printf("\n");
}

void mergeSort_divide(int boo[], int m, int n) {
	int mid;
	if (m<n) {
		mid = (m + n) / 2;
    
	mergeSort_divide(boo, m, mid);		     
	mergeSort_divide(boo, mid + 1, n);	     
		
	merge_conquer_combine(boo, m, mid, n);   
	}
}
void main() {
	int i;
	size = 8;

    printf("<<(2-way merge sort):  >>\n\n");
	
    printf("* before sorting data:  ");
	for(i=0; i<N; i++) {
	   printf("%3d", ken[i]);
	}
    printf("\n\n");
	printf("--------------------------------------------\n");
	
	mergeSort_divide(ken, 0, N - 1); 

    printf("\n");
	printf("------------------------------------------\n\n");
    printf("* after sorting data: ");
    for (i=0; i<N; i++) {
       printf("%3d", sort_result[i]);
	}
    printf("\n");

	getchar();
}
