#include <stdio.h>
#include <stdlib.h>

int c_suja; 
typedef struct SUJA_LIST {
	int		c_suja;
	int		e_suja;
	struct SUJA_LIST  *daeum;
} SUJA_LIST;

typedef struct startList {
	SUJA_LIST* start;
} startList;

startList* get_L(void) {
	startList* L;
	L = (startList *)malloc(sizeof(startList));
	L->start = NULL;
	return L;
}

void insert_T(startList* L, int c_suja, int e_suja) {
	SUJA_LIST* new_N;
	SUJA_LIST* p;
	new_N = (SUJA_LIST *)malloc(sizeof(SUJA_LIST));
	new_N->c_suja = c_suja;
	new_N->e_suja = e_suja;
	new_N->daeum = NULL;

	if (L->start == NULL) {		
		L->start = new_N;
		return;
	}
	else {						
		p = L->start;
		while (p->daeum != NULL) {
			p = p->daeum;			 
		}
	p->daeum = new_N;		 
	}
}

void addPoly(startList* A, startList* B, startList* C) {
	struct SUJA_LIST* pA = A->start;
	struct SUJA_LIST* pB = B->start;
	int hap;

	while (pA && pB) {
		if (pA->e_suja == pB->e_suja) {
			hap = pA->c_suja + pB->c_suja;
			insert_T(C, hap, pA->e_suja);
			pA = pA->daeum; pB = pB->daeum;
		}
		else if (pA->e_suja > pB->e_suja) {
			insert_T(C, pA->c_suja, pA->e_suja);
			pA = pA->daeum;
		}
		else {
			insert_T(C, pB->c_suja, pB->e_suja);
			pB = pB->daeum;
		}
	}
	
	for (; pA != NULL; pA = pA->daeum)
		insert_T(C, pA->c_suja, pA->e_suja);

	for (; pB != NULL; pB = pB->daeum)
		insert_T(C, pB->c_suja, pB->e_suja);
}

void dis_P(startList* L) {
	SUJA_LIST* p = L->start;
	for (; p; p = p->daeum) {
		printf("%3dx^%d", p->c_suja, p->e_suja);
		if (p->daeum != NULL) printf(" +");
	}
}

main() {
	int c, e, i; 
	startList *A, *B, *C;

	printf("*****  Ʈ Ȱ ׽  *****\n\n"); 
	printf("\n================================================\n");
	A = get_L();  
	printf("<  Է(׸ 3 Է)> \n");
	for (i=0; i < 3; i++) {
	    printf("A(x): ׸ 2[  ] 3 Է ==>"); 
	    scanf("%d %d", &c, &e); insert_T(A, c, e);
	}
	printf("\n A(x) = "); dis_P(A); 
	printf("\n------------------------------------------\n");

	B = get_L();  
	printf("\n\n<  Է(׸ 4 Է)> \n");
	for (i=0; i < 4; i++) {
	    printf("B(x): ׸ 2[  ] 4 Է ==>"); 
	    scanf("%d %d", &c, &e); insert_T(B, c, e);
	}
	printf("\n B(x) = "); dis_P(B); 
	printf("\n------------------------------------------\n");

	printf("\n\n< ׽ [A(x) + B(x)] > \n");
	C = get_L();   
    addPoly(A, B, C); 
	printf("\n C(x) = "); dis_P(C);   
	printf("\n================================================\n\n");

	getchar();
}