#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct stackNode {	
	int data;
	struct stackNode *link;
} stackNode;

stackNode *top;				

int isEmpty() {
	if (top == NULL) return 1;
	else return 0;
}

void push(int item) {
	stackNode* temp = (stackNode *)malloc(sizeof(stackNode));
	temp->data = item;
	temp->link = top;     
	top = temp;           
}

int pop() {
	int item;
	stackNode* temp = top;

	if (top == NULL) {		
		printf("\n\n Stack is empty !\n");
		return 0;
	}
	else {					
		item = temp->data;
		top = temp->link;	
		free(temp);			
		return item;		
	}
}

void d_stack() {
	stackNode* p = top;
	int i;
	printf("\n current STACK state(top==>bottom): ");
	while(p) {
		putch(p->data);
		p = p->link;
	}
	printf("\n");
}

void main(void) {
	int item;
	top = NULL;
	
	 printf("<< ̿ (stack)  >>\n\n");
	 while(1) {
	    printf("\n---- Selection number(1, or 2, or 0) ---\n");
	    printf("  1.push    2.pop    0.end \n");
  	    printf("----------------------------------------\n\n");
	    switch(getch()) {
  	        printf("----- Press character ------------------\n");
		case '1': printf("PUSH: ");
			      printf("  key pressed ==> "); push(getche()); d_stack();            //             
				  printf("\n");
	              printf("      key pressed ==> "); push(getche()); d_stack();		// 
	              printf("\n");
	              printf("      key pressed ==> "); push(getche()); d_stack();		// 
				  printf("\n");
				  printf("  key pressed ==> "); push(getche()); d_stack();            //             
				  printf("\n");
	              printf("      key pressed ==> "); push(getche()); d_stack();		// 
	              printf("\n");
	              break;
		case '2': printf("POP:  ");
				  putch(pop()); d_stack();		
	              printf("\n");
	              printf("POP:  ");
				  putch(pop()); d_stack();		
	              printf("\n");
				  printf("POP:  ");
	              putch(pop()); d_stack();		
	              printf("\n");
				  printf("POP:  ");
	              putch(pop()); d_stack();		
	              printf("\n");
				  printf("POP:  ");
	              putch(pop()); d_stack();		
	              printf("\n");
	              break;
		case '0': return;
		}	
	}
}