#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 4
int queue[MAX];
int front=0;
int rear=-1;
char deletion();
char insertCQueue(int q_in);
char deleteCQueue();

void main()
{
    printf("<<迭 ̿  ť(Circular Queue)  >>\n");
	while(1) {
		printf("\n---- Selection number(1, or 2, or 0) ---\n");
		printf("  1.insertion    2.deletion  0.end \n");
		switch(getch()) {
  	        printf("----- Press character ------------------\n");
		    case '1': printf("Queue Insertion: ");
		              insertCQueue(getch());
			          deleteCQueue();
			          break;
		    case '2': printf("Queue Deletion: %c", deletion());
			          deleteCQueue();
			          break;
		    case '0': return;
		}	
	}
}

char insertCQueue(int q_in)
{
	rear = (rear +1) % MAX;
	queue[rear] = q_in;
}

char deleteCQueue()
{
	int i;
	printf(" current QUEUE state: ");
	front = front % MAX; 
	for(i=front; i<=rear; i++)
		putchar(queue[i]);
	printf("\n");
}	

char deletion()
{
	char q_out;
	q_out = queue[front];
	front = (front + 1) % MAX;
	 
	return q_out;
}

