#include<stdio.h> 
#include<stdlib.h> 
#define N 8

typedef struct BST_Node {
	int data;			
	struct BST_Node* left;	
	struct BST_Node* right;	
} BST_Node;

BST_Node* insert_BST(BST_Node *p, int x) {
	BST_Node *nNode;
	if (p == NULL) {
		nNode = (BST_Node*)malloc(sizeof(BST_Node));
		nNode->data = x;
		nNode->left = NULL;
		nNode->right = NULL;
		return nNode;
	}
	else if (x < p->data)  p->left = insert_BST(p->left, x);
	else if (x > p->data)  p->right = insert_BST(p->right, x);
	else  printf("\n  Ű !! \n");

	return p;
}

void inorder_BST(BST_Node* root) {
	if (root) {
		inorder_BST(root->left);
		printf(" %d", root->data);
		inorder_BST(root->right);
	}
}

void sort_BST(int bbb[], int n) {
	int i;

	BST_Node* root = NULL;			
	root = insert_BST(root, bbb[0]);	

	for (i = 1; i<n; i++)		
		insert_BST(root, bbb[i]);		
	inorder_BST(root);			
}

int main() {
	int ken[N] = {27, 6, 78, 2, 62, 12, 60, 16};
	int i;

	printf("\n=====  Ž Ʈ () ===== \n\n");
	printf("** before sorting data:  ");
	for(i=0; i<N; i++) {
	   printf("%3d", ken[i]);
	}
    printf("\n\n");
		
	printf("** after sorting data:  ");
	sort_BST(ken, N);
	
	getchar();
}