#include <stdio.h>
#include <string.h>

#define SLOTSIZE 100
#define MOD 26

int hashing(char *);

struct id
  {
    char name[10];
    char address[10];
    char telno[10];
    int flag;
  } std[SLOTSIZE];

main()
{
   int k;
   char ken[10], boo[10], yoo[10];

   
   printf("*** Hashing for collision(open addressing method)***\n\n");
   printf("Input your name, Address, Tel #\n");
   while (scanf("%s %s %s", ken, boo, yoo) !=EOF)
     {
       k=hashing(ken);
       while (std[k].flag==1 && k<SLOTSIZE)
	     k++;
       if (k<SLOTSIZE)
	   {
	    strcpy(std[k].name, ken);
	    strcpy(std[k].address, boo);
	    strcpy(std[k].telno, yoo);
	    std[k].flag=1;
	   }
       else
	   printf("table full!!\n");
     }

   rewind(stdin);

   printf("Input data for searching\n");
   while (scanf("%s", ken) != EOF)
     {
       k=hashing(ken);
       while (strcmp(ken, std[k].name) != 0 && k<SLOTSIZE)
	     k++;
       if (k<SLOTSIZE)
	  printf("%3d%13s%13s%13s\n",k,std[k].name,std[k].address,std[k].telno);
       else
	  printf("search data not found!!!\n");
     }
getchar();
}

int hashing(char *str)
{
   int n, m=0, i;

   n = strlen(str);
   for(i=0; i<n; i++)
      m += (str[i] - 'A' + 1);
   m = m % MOD;
   return m;
}
