#include <stdio.h>

#define TRUE 1
#define FALSE 0

#define VERT 6
#define INF 50000L

int adj_M[VERT][VERT]={
{ 0, 16, INF, INF, 19, 21},
{ 16,  0, 5, 6, INF, 11 }, 
{ INF, 5, 0, 10, INF, INF },
{ INF, 6, 10, 0, 18,14 },
{ 19, INF, INF, 18, 0, 33 },
{ 21, 11, INF, 14, 33, 0 }}; 

int s_V[VERT];
int distanceV[VERT];

int get_min_V(int n)
{
  int v,i, j;
  for (i = 0; i <n; i++)
    if (!s_V[i]) {
      v = i; 
	  break;
    }
  
  for (i = 0; i < n; i++)
    if ( !s_V[i] && (distanceV[i] < distanceV[v])) 
	   { printf(" [ġ ] %d < %d",distanceV[i], distanceV[v]);  
         v = i;}

  if (v != 0)
  	  printf(" =>  ġ %d",distanceV[v]);
  
  return (v);
}

void primSpanning(int s, int n)
{
	int i, u, v, sum=0;

	for(u=0;u<n;u++)
		distanceV[u]=INF;

	distanceV[s]=0;
	
	for(i=0;i<n;i++){
		u = get_min_V(n);
		s_V[u]=TRUE;

		if( distanceV[u] == INF ) return;
		   printf("\n : %d ==>", u+1);
		
		for( v=0; v<n; v++) {
			if( adj_M[u][v]!= INF) 
				if( !s_V[v] && adj_M[u][v]< distanceV[v] ) {
					distanceV[v] = adj_M[u][v];
				    printf(" ġ: %d", distanceV[v]);
				}				
		}
    }
  for(i=0; i<VERT; i++) 
	  sum += distanceV[i];
  printf(" Ʈ ϼ: Ѻ== %d", sum);
}

main()
{
   int i, j;

    printf("======= ּ   Ʈ ϱ =======\n");
	printf("\n***** ġ ׷(7*7) *****\n");
    for (i = 0; i < VERT; i++) {
	     for (j = 0; j < VERT; j++) {
			  if (adj_M[i][j] == 50000L)
				  printf("%4c", '*');
	          else printf("%4d", adj_M[i][j]);
	     }
	    printf("\n");
	}
	printf("\n***** (prim)  *****\n");
	primSpanning(0, VERT);

    getchar();
}